<?php

/**************************************************************
*  Bartemis                                                  *
* Les grecs avaient Artemis, vous avez Bartemis.              *
* ____________________________________________________________*
* Version :          1.2.8                                    *
* Date de sortie :   28 dcembre 2009                         *
* Dernire Modification :   11 septembre 2010                 *
* Ce logiciel est sous licence libre et est distribu sans    *
* aucune garantie, lire licences.txt pour plus de prcisions. *
* ____________________________________________________________*
* bs-includes/general.php                                     *
***************************************************************/

function mysql_connectf2 () {

	include dirname(__FILE__).'/../config.php';

	$connect = mysql_connect($serveur, $nom_utilisateur, $pass)
		or die('Impossible de se connecter : ' . mysql_error());
		
		mysql_select_db($base_de_donnee, $connect); 
}

function wordCut($chaine, $max, $sMessage)
{
	if(strlen($chaine)>=$max){
  
		$chaine=substr($chaine,0,$max); 

		$espace=strrpos($chaine," "); 
		
		if($espace)
		
			$chaine=substr($chaine,0,$espace);

		$chaine .= $sMessage;
	}
	
  return $chaine;
}

function clean($str)
{
	$str = str_replace('&','et',$str);
	
	if($str !== mb_convert_encoding(mb_convert_encoding($str,'UTF-32','UTF-8'),'UTF-8','UTF-32'))
		
		$str = mb_convert_encoding($str,'UTF-8');
		
	$str = htmlentities($str,ENT_NOQUOTES,'UTF-8');
	
	$str = preg_replace('`&([a-z]{1,2})(acute|uml|circ|grave|ring|cedil|slash|tilde|caron|lig);`i','$1',$str);
	
	$str = preg_replace(array('`[^a-z0-9]`i','`[-]+`'),'-',$str);
	
	$str = strtolower(trim($str,'-'));
	
	return $str;
}

function head() {

	include dirname(__FILE__).'/../config.php';
	
	$generator = 'Bartimus '.$version;
	
	$head = '';
	
if (isset($_GET['act'])){
	
	// Fiche site
	if($_GET['act']=='1'){
	
		$id_site = intval($_GET['id']);
		
		$site = rcp_site($id_site, '', '', '', '', '');
		
		$s = $site[0];
		
		update_c (1, $id_site, $s['compteur']);
					
		if ($s['type'] == 1 AND $s['valide'] == 1) {
							
			$head.= '<title>'.broken_html ($s['titre']).' - ('.url_www ($s['url']).')</title>';
			$head.= '<meta name="description" content="'.broken_html ($s['titre']).' que l\'on trouvera grce  l\'URL '.url_www ($s['url']).' est un site taitant de '.broken_html ($se['titre']).' et class dans la catgorie '.broken_html ($c['titre']).' de l\'annuaire '.$titre_annuaire.'." />';
			$head.= '<meta name="keywords" content="'.broken_html ($s['titre']).','.url_www ($s['url']).','.broken_html ($s['titre']).','.broken_html ($se['titre']).','.broken_html ($c['titre']).', annuaire, lien dur" />';
			$head.= '<meta name="category" content="'.$s['info']['cat']['titre'].'">'."\n";
			$head.= '<link rel="canonical" href="'.$s['info']['permanlink'].'" />';
			$head.= '<meta name="robots" content="index, follow">';
			$head.= '<meta name="generator" content="'.$generator.'">';
			
		}
		
		else {
		
			$head = '<meta http-equiv="Refresh" content="0;URL='.$url_annuaire.'" />';
			$head.= '<meta name="robots" content="noindex">';
							
		}
			
	}
	
	//Section
	elseif($_GET['act']=='2'){
		
		$id_sect = intval($_GET['id']);
		
		$sect = rcp_sect($id_sect, "", "");
		
		$se = $sect[0];
			
		update_c (2, $id_sect, $se['compteur']);
						
		$pt = intval($_GET['p']);
						
		if (!empty($pt))
			$page = ' '.$pt; 
						
		$head.= '<title>'.broken_html ($se['titre']).$page.'   '.broken_html ($se['info']['cat']['titre']).'</title>';
		$head.= '<meta name="description" content="Trouvez dans cette section de l\'annuaire tout les sites parlant de '.broken_html ($se['titre']).' class dans '.broken_html ($c['titre']).' de l\'annuaire '.$titre_annuaire.'." />';
		$head.= '<meta name="keywords" content="'.broken_html ($se['titre']).','.broken_html ($c['titre']).', annuaire" />';
		$head.= '<meta name="category" content="'.broken_html ($se['info']['cat']['titre']).'">';
						
		if (intval($_GET['p']) == '0')
			$head.= '<link rel="canonical" href="'.$se['info']['permanlink'].'" />';
                     
		elseif (isset($_GET['p']))
			$head.= '<link rel="canonical" href="'.$se['info']['permanlink'].'?p='.intval($_GET['p']).'" />';
			
		else 
			$head.= '<link rel="canonical" href="'.$se['info']['permanlink'].'" />';
						
						
		$head.= '<meta name="robots" content="index, follow">';
		
	}
	
	//Categorie
	elseif($_GET['act']=='3'){
		
		$id_cat = intval($_GET['id']);
		
		$cat = rcp_cat($id_cat, '');
		
		$c = $cat[0];
			
		update_c (3, $id_cat, $c['compteur']);
		
		$head.= '<title>'.broken_html ($c['titre']).'  '.$titre_annuaire.'</title>';
		$head.= '<meta name="description" content="La catgorie '.broken_html ($c['titre']).' est sur l\'annuaire '.$titre_annuaire.'." />';
		$head.= '<meta name="keywords" content="'.broken_html ($c['titre']).', annuaire" />';
		$head.= '<meta name="category" content="'.broken_html ($c['titre']).'">';
		$head.= '<link rel="canonical" href="'.$c['info']['permanlink'].'" />';
		$head.= '<meta name="robots" content="index, follow">';
		
	}
	
	//Page
	elseif($_GET['act']=='4'){
	
		$id_page = $_GET['id'];
		
		$page = rcp_page($id_page, $order);
			
		$p = $page[0];
			
		update_c (4, $p['id_page'], $p['compteur']);
				
		$head.= '<title>'.broken_html ($p['titre']).' - '.$titre_annuaire.'</title>';
		$head.= '<meta name="description" content="'.broken_html ($p['titre']).' est sur l\'annuaire - '.broken_html(wordcut($p['contenu'], 120, '...')).'" />';
		$head.= '<meta name="keywords" content="'.broken_html ($p['titre']).', annuaire" />';
		$head.= '<link rel="canonical" href="'.$p['info']['permanlink'].'" />';
		$head.= '<meta name="robots" content="index, follow">';
		
	}
	//Ajouter
	elseif($_GET['act']=='ad') {
	
		$head.= '<title>Ajouter un site sur l\'annuaire '.$titre_annuaire.'</title>';
		$head.= '<meta name="description" content="Ajouter vite votre site sur l\'annuaire '.$titre_annuaire.', annuaire de qualit et lien en dofollow" />';
		$head.= '<link rel="canonical" href="'.$url_annuaire.'ajouter.html" />';
		$head.= '<meta name="keywords" content="Ajouter mon site, annuaire en dofollow, annuaire, lien en dofollow, backlinks, dofollow" />';
		$head.= '<meta name="robots" content="index, follow">';
	
	}
	
	//Resultat de l'ajout
	elseif($_GET['act']=='aj') {
	
		$head.= '<title>Ajouter un site sur l\'annuaire '.$titre_annuaire.'</title>';
		$head.= '<meta name="description" content="Ajouter vite votre site sur l\annuaire '.$titre_annuaire.', annuaire de qualit et lien en dofollow" />';
		$head.= '<link rel="canonical" href="'.$url_annuaire.'ajouter2.html />';
		$head.= '<meta name="keywords" content="Site ajout, ajout mon site, annuaire en dofollow, annuaire, lien en dofollow, backlinks, dofollow" />';
		$head.= '<meta name="robots" content="index, follow">';
		
	}
 
}
else {
		$head.= '<title>'.$titre_annuaire.'</title>';
		$head.= '<meta name="description" content="'.broken_html ($description_annuaire).'" />';
		$head.= '<meta name="keywords" content="'.$keywords_annuaire.', annuaire" />';
		$head.= '<meta name="robots" content="index, follow">';
		$head.= '<link rel="canonical" href="'.$url_annuaire.'" />';
}
		$head.= '<meta name="generator" content="'.$generator.'">';
		
  return $head;
}

function copyright() {

	$copyright = '<div id="copyright">Annuaire propuls par <a href="http://www.bartemis.com/" title="Script d\'annuaire PHP">Bartemis</a>';
	
	return $copyright;
}

function parse_rss($url, $nb_items_affiches=5) {

    $rss = fetch_rss( $url );
	
	if(fetch_rss( $url )) {

		if (is_array($rss->items)){
		
			$items = array_slice($rss->items, 0, $nb_items_affiches);
			echo '<ul>';

			foreach ($items as $item) {
			
			  $href = $item['link'];
			  
			  $title = str_replace('?', "'", $item['title']);
			  
			  echo '<li><a href="'.$href.'">'.htmlspecialchars($title).'</a>';
			  
			  echo '</li>';
			  
			}
			echo '</ul>';
			
		}
		else{
			echo 'Impossible de lire ce flux';
		}
	
	} else {
	
		echo 'Flux indisponible pour le moment';
		
	}
}

function url_www ($url) {
	$url = str_replace("http://", "", $url);
	$url = str_replace("www.", "", $url);
	if (substr($url, -1) == '/') {
	$url = substr($url,0,strlen($url)-1);
	}
	return $url;
}
 
function broken_html ($texte) {

	$texte = strip_tags($texte);
	$texte = htmlspecialchars($texte);
	$texte = str_replace('"', '', $texte);
	$texte = stripslashes($texte);
	
	return $texte;
 
}

function vider_cache($dossier) {
	

	$repertoire = opendir($dossier);
 
	while (false !== ($file = readdir($repertoire))) {
	
		$way = $dossier.'/'.$file;
 
		if ($file != '..' AND $file != '.' AND !is_dir($file))  {
		
			unlink($way);
       
	   }
}

	closedir($repertoire);

}

function valid_mail($email){
	
	$format_email='#^[\w.-]+@[\w.-]+\.[a-zA-Z]{2,6}$#';
	
	if(preg_match($format_email,$email)) {
      
		$domaine_extrait=preg_replace('!^[a-z0-9._-]+@(.+)$!', '$1', $email);
	  
		$domaine_bloques= array ('jetable.com', 'ephemail.net', 'yopmail.com', 'spamgourmet.com', 'haltospam.com', 'iximail.com', 'guerrillamail.com', '0-mail.com', 'spam.la', 'mytempemail.com', 'saynotospams.com', 'tempemail.co.za', 'mailinator.com', 'mytrashmail.com', 'mailexpire.com', 'maileater.com', 'spambox.us', '10minutemail.com', 'dontreg.com', 'tempomail.fr', 'spamfree24.org', 'lemailcprivee.com' );
		
	if (in_array($domaine_extrait, $domaine_bloques)) {
		return 1;
	}
	
	} else { return 1; }
	
}

function convert_br($texte, $sens) {

	if(intval($sens) == 1)  {
		$text = str_replace("<br />", CHR(10), $texte);
		
	} else {
		$text = nl2br($texte);
	}
		
	return $text;

}



function captcha() {

   $typeCaptcha = mt_rand(1,3);
   
   $matrix_blur = array(
      array(1,1,1),
      array(1,1,1),
      array(1,1,1)
   );
   
   $imageCaptcha = imagecreate(220,30);
   
   $gris = imagecolorallocate($imageCaptcha, 159, 159, 159);
   
   $blanc = imagecolorallocate($imageCaptcha, 255, 255, 255);
   
   if($typeCaptcha == 1) {
   
      $question = " Veuillez recopier le code ci-dessous (la casse compte) ";
      
      $str = " abcdefghijkmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ23456789?";
      
      $str = str_shuffle($str);
      
      $final_str = ' ';
      
      $resultat =  "";
      
      for($i=0; $i<6; $i++){
      
         $final_str .= $str[$i].' ';
         $resultat .= $str[$i];
         
      }
      
      imagettftext($imageCaptcha, 25, 0,20,26, $blanc, 'images/sixty.ttf', $final_str);
      
   }
   else {
   
      $question = " Veuillez rsoudre la question suivante (crire en chiffre)";
      $nombre1 = mt_rand(0,10);
      $nombre2 = mt_rand(0,10);
      $resultat = $nombre1 + $nombre2;
      $nombres = array('zero', 'un', 'deux', 'trois', 'quatre', 'cinq', 'six', 'sept', 'huit', 'neuf', 'dix');
      
      if($typeCaptcha == 2) {
      
         $questionCaptcha = $nombres[$nombre1] .' + '.$nombres[$nombre2].' = ?';
         imagestring($imageCaptcha, 10, 10, 5, $questionCaptcha, $blanc);
      
      }
      else {
      
         $questionCaptcha = $nombres[$nombre1] .' +  ? = '.$resultat;
         $resultat = $nombre2;
         imagestring($imageCaptcha, 10, 10, 5, $questionCaptcha, $blanc);
      }
   }
   imagepng($imageCaptcha, "captcha.png");
   
   echo $question, "<br />";
   
   echo "<img src='captcha.png' alt='captcha' />";
   
   $_SESSION['captcha'] = $resultat;
}

function mail_inscription_refuse() {

	global $_POST, $s, $titre_annuaire, $url_annuaire, $mail;
	
	$contenu = file_get_contents((dirname(__FILE__).'/../config/mail_inscription_refuse.txt'));
	
	$contenu = str_replace('%url_annuaire%', $url_annuaire, $contenu);
	$contenu = str_replace('%motif%', $_POST['motif'], $contenu);
	$contenu = str_replace('%titre_annuaire%', stripslashes($titre_annuaire), $contenu);
	$contenu = str_replace('%titre_site%', stripslashes($s['titre']), $contenu);
	$contenu = str_replace('%description%', stripslashes($s['description']), $contenu);
	
	if(mail(trim($s['mail_auteur']),  'Site non accept', stripslashes($contenu), 'From: "Annuaire '.$titre_annuaire.'"<'.$mail.'>'."\n".'Reply-To: '.$mail."\n".'Content-Type: text/plain; charset="iso-8859-1"'."\n".'Content-Transfer-Encoding: 8bit'))
		return true;
	else
		return false;
}

function getHost($Address) {
	   $parseUrl = parse_url(trim($Address));
	   return trim($parseUrl['host'] ? $parseUrl['host'] : array_shift(explode('/', $parseUrl['path'], 2)));
}

function plugin_install($id) {

	modifier_fichier('plugins.txt', '../config/plugins.txt', 'tr', 'tr;'.$id);

}

function check_plugin($id) {

	global $url_annuaire;

	$plugins = explode(';', @file_get_contents($url_annuaire.'config/plugins.txt'));
	
	if(array_search($id, $plugins) === false)
		return true;
	else 
		return false;
}