<?php

/**************************************************************
*  Bartemis                                                  *
* Les grecs avaient Artemis, vous avez Bartemis.              *
* ____________________________________________________________*
* Version :          1.2.8                                    *
* Date de sortie :   28 dcembre 2009                         *
* Dernire Modification :   11 septembre 2010                 *
* Ce logiciel est sous licence libre et est distribu sans    *
* aucune garantie, lire licences.txt pour plus de prcisions. *
* ____________________________________________________________*
* Template par default                                        *
***************************************************************/

if (file_exists(dirname(__FILE__).'/../../config.php')) {

	include dirname(__FILE__).'/../../config.php';
	
}

else {

	$couleur = 'e2007a';

	$couleur2 = 'b70264';

}


header('Content-type: text/css');
?>
html,body{height:100%;width:100%}
body{background-color:white;
font-family:"Segoe UI",Calibri,"Myriad Pro",Myriad,"Trebuchet MS",Helvetica,Arial,sans-serif;
font-size:15px;font-style:normal;color:#4e4e4e;}
div {margin: 0}



a{color:#<?php echo $couleur; ?>;outline:none;text-decoration: none}
a:hover{color:#<?php echo $couleur2; ?>;text-decoration:none}

.width {width:974px; text-align :justify}

table{margin:.5em 0 1em;}
table td,table th{text-align:left;border-right:1px solid #fff;padding:.4em .8em;}
table th{background-color:#5e5e5e;color:#fff;text-transform:uppercase;font-weight:bold;border-bottom:1px solid #e8e1c8;}
table td{background-color:#eee;}
table th a{color:#d6f325;}
table th a:hover{color:#fff;}
table tr.even td{background-color:#ddd;}
table tr:hover td{background-color:#fff;}

<?php //h1{font-weight:normal;font-size:270%;letter-spacing:-.04em;line-height:100%;margin:.8em 0 .2em;} ?>
h1, h2{font-weight:normal;font-size:200%;letter-spacing:-.04em;line-height:110%;margin:.7em 0 .2em;}
h3{font-size:160%;font-weight:normal;letter-spacing:-.04em;line-height:110%;margin:.7em 0 .2em;text-shadow:#fff 1px 1px 1px;}
h4{font-size:140%;font-weight:bold;margin:.7em 0 .2em;}
h5{font-family:"Palatino Linotype", Georgia, Serif;font-size:140%;font-weight:bold;margin:.5em 0 .2em;letter-spacing:-.02em;}
h6{font-size:120%;font-weight:normal;text-transform:uppercase;margin:.5em 0 .2em;}


input:hover.soumettre_input {border : 1px solid #<?php echo $couleur; ?>;}
input.soumettre_input {border : 1px solid #e5e5e5;}
span.conseil {font-size: 13px;color:#<?php echo $couleur2; ?>; padding-left:20px; background:transparent url(images/puce-<?php echo $couleur; ?>.png) no-repeat;}
td.conseltd {border-bottom: 1px solid #e5e5e5}
textarea:hover.soumettre_textarea {border : 1px solid #<?php echo $couleur; ?>;}
textarea.soumettre_textarea {width:100%; height:350px; margin-left:25px;margin-right:25px}

table.formulaire tr:hover td{background-color:transparent;}
table.formulaire td{background-color:transparent;}

fieldset { border: 0 }

.align_right {text-align: right }
.align_left {text-align: left}
.align_center {text-align: center}
.align_justify {text-align: justify}

.titre_site {font-size: 25px; }
div.titre_site {border-bottom: 1px dotted #e5e5e5;margin-bottom:15px}
.titre_site {font-size: 25px;color:#<?php echo $couleur; ?>;text-align:center}

.liste_site {list-style-type:none}
.liste_site li {padding: 10px;margin:5px; border:1px solid transparent}
.liste_site li:hover {background-color:#f5f5f5; border:1px dotted #e5e5e5}

li.site_modulo {background-color:#f5f5f5; border:1px dotted #e5e5e5}

.description_site { padding-left: 15px}

.padding{padding:5px}

.fluxrss li{list-style:square inside url(images/puce2-<?php echo $couleur; ?>.png);}
div.thumbs {float:left;padding-right:10px;}

table.liste_section {border: 1px dotted #e5e5e5}
table.liste_section tr td{background-color:transparent;}
table.liste_section tr td:hover{background-color:#f5f5f5;}

.color_titre {padding-bottom: 3px; color:#<?php echo $couleur; ?>;font-size: 25px; border-bottom: 1px dotted #e5e5e5}

.li_section {color: #4e4e4e}

.description_annu {font-size:16px; padding:15px;text-align:center}
.page_annu{font-size:16px; padding:15px;text-align:left}

#fil_ariane { border: 1px dotted #e5e5e5; margin:1px; padding:1px; max-width:974px }

#colonne {width:25%;float:right; margin-top:50px}
.titre_colonne {font-size: 20px;color:#<?php echo $couleur; ?>;text-align:center; background-color:#e5e5e5;padding-bottom:3px;margin:0px }
.widget_colonne {text-align: left;border-bottom:1px dotted #e5e5e5;border-right:1px dotted #e5e5e5;border-left:1px dotted #e5e5e5;margin-top:-12px;padding:0}
#colonne ul li {list-style:square url(images/puce2-<?php echo $couleur; ?>.png);}
#colonne ul li a {color:#4e4e4e;}
#colonne ul li a:hover {color:#<?php echo $couleur2; ?>}

#footer {text-align:center;border-top:1px dotted #e5e5e5; padding-top:15px; padding-bottom:25px;margin-top:5px}

.clear{clear:both;height:0;}

.space {margin-top:5px}

.contenu {width:74%;float:left;}
.annuaire_titre {font-weight:normal;font-size:270%;letter-spacing:-.04em;line-height:100%;margin:.8em 0 .2em;padding-bottom: 10px}

.ajouter{font-size:17px; font-weight:bold}

a.lien_section {color:#4e4a4a;font-size:14px}
a:hover.lien_section {color:#<?php echo $couleur2; ?>;font-size:14px}
span.lien_section {padding-left:20px; background:transparent url(images/puce-<?php echo $couleur; ?>.png) no-repeat;}

.separation {border-bottom: 1px dotted #e5e5e5}

.navp {text-align:center;margin:5px}
.navp a {padding:4px;margin-left:2px; border:1px solid #e5e5e5}
.navp a:hover {background-color:#<?php echo $couleur; ?>}
.navp .active {padding:4px;margin-left:2px; border:1px solid #e5e5e5}